class SBFlyingFish extends Fly;


var() byte
	BiteDamage,		// Basic damage done by bite.
	RipDamage;
var bool bAttackBump;
var(Sounds) sound bite;
var(Sounds) sound rip;
var float AirTime;



function PlayBite(float decision) {

	if (decision < 0.55)
		PlayAnim('Bite1', 0.3);
	else if (decision < 0.8)
		PlayAnim('Bite2', 0.3);
	else
		PlayAnim('Bite3', 0.3);
}


// RazorFish functions.

function WhatToDoNext(name LikelyState, name LikelyLabel)
{
	bStasis = true;
	Super.WhatToDoNext(LikelyState, LikelyLabel);
}

function ZoneChange(ZoneInfo newZone) {
}


function PreSetMovement() {
	super.PreSetMovement();
	bCanSwim = true;
}


function eAttitude AttitudeToCreature(Pawn Other) {
	if (Other.IsA(self.Class.name))
		return ATTITUDE_Friendly;
	else
		return ATTITUDE_Ignore;
}


function PlayChallenge() {
	PlayBite(FRand());
}


function PlayWaiting() {
	LoopAnim('Swimming', 0.1 + 0.3 * FRand());
}

function PlayPatrolStop() {
	LoopAnim('Swimming', 0.1 + 0.3 * FRand());
}

function PlayWaitingAmbush() {
	LoopAnim('Swimming', 0.1 + 0.3 * FRand());
}

function TweenToFighter(float tweentime) {
	TweenAnim('Fighter', tweentime);
}

function TweenToRunning(float tweentime) {
	if ( (AnimSequence != 'Swimming') || !bAnimLoop )
		TweenAnim('Swimming', tweentime);
}

function TweenToWalking(float tweentime) {
	if ( (AnimSequence != 'Swimming') || !bAnimLoop )
		TweenAnim('Swimming', tweentime);
}


function TweenToWaiting(float tweentime) {
	PlayAnim('Swimming', 0.2 + 0.8 * FRand());
}


function TweenToPatrolStop(float tweentime) {
	TweenAnim('Swimming', tweentime);
}


function PlayRunning() {
	LoopAnim('Swimming', -0.8/WaterSpeed,, 0.4);
}


function PlayWalking() {
	LoopAnim('Swimming', -0.8/WaterSpeed,, 0.4);
}


function PlayThreatening() {
	if ( FRand() < 0.5 )
		PlayAnim('Swimming', 0.4);
	else
		PlayAnim('Fighter', 0.4);
}


function PlayTurning() {
	LoopAnim('Swimming', 0.8);
}


function PlayDying(name DamageType, vector HitLocation) {
	if ( Region.Zone.bWaterZone )
	{
		PlaySound(Die, SLOT_Talk, 4 * TransientSoundVolume);
		PlayAnim('Dead1', 0.7, 0.1);
	}
	else
		TweenAnim('Breathing', 0.35);
}


function PlayTakeHit(float tweentime, vector HitLoc, int damage) {
	TweenAnim('TakeHit', tweentime);
}


function TweenToFalling() {
	TweenAnim('Flopping', 0.2);
}


function PlayInAir() {
	LoopAnim('Swimming', 0.7);
}


function PlayLanded(float impactVel) {
	TweenAnim('breathing', 0.2);
}


function PlayVictoryDance() {
	PlayAnim('ripper', 0.6, 0.1);
}


function PlayMeleeAttack() {
local vector adjust;
local float decision;
	adjust = vect(0,0,0.5) * FRand() * Target.CollisionHeight;
	Acceleration = AccelRate * Normal(Target.Location - Location + adjust);
	bAttackBump = false;
	if (AnimSequence == 'Grab1')
	{
		PlayAnim('ripper', 0.5 + 0.5 * FRand());
		PlaySound(rip,SLOT_Interact,,,500);
		MeleeDamageTarget(RipDamage, vect(0,0,0));
		Disable('Bump');
		return;
	}
	decision = FRand();
	PlaySound(bite,SLOT_Interact,,,500);
	if (decision < 0.3)
	{
		Disable('Bump');
		PlayAnim('Grab1', 0.3);
		return;
	}

	Enable('Bump');
	PlayBite(decision);
}


state Attacking {

	function Landed(vector HitNormal) {
		SetPhysics(PHYS_Swimming);
	}
}


state MeleeAttack {
ignores SeePlayer, HearNoise;

	singular function Bump(actor Other) {
		Disable('Bump');
		if ( (AnimSequence == 'Bite1') || (AnimSequence == 'Bite2') || (AnimSequence == 'Bite3') )
			MeleeDamageTarget(BiteDamage, (BiteDamage * 1000.0 * Normal(Target.Location - Location)));
		else
			return;
		bAttackBump = true;
		Velocity *= -0.5;
		Acceleration *= -1;
		if (Acceleration.Z < 0)
			Acceleration.Z *= -1;
	}

	function KeepAttacking() {
		if ( (Target == None) ||
			((Pawn(Target) != None) && (Pawn(Target).Health == 0)) )
			GotoState('Attacking');
		else if ( bAttackBump && (FRand() < 0.5) )
		{
			SetTimer(TimeBetweenAttacks, false);
			GotoState('TacticalMove', 'NoCharge');
		}
	}
}


state TacticalMove {
ignores SeePlayer, HearNoise;

	function Bump(Actor Other)
	{
		Disable('Bump');
		if (bAttackBump == true)
			bAttackBump = false;
		else if (Other == Enemy)
		{
			bReadyToAttack = true;
			Target = Enemy;
			GotoState('MeleeAttack');
		}
		else if (Enemy.Health <= 0)
			GotoState('Attacking');
	}


BackOff:
	Acceleration = AccelRate * Normal(Location - Enemy.Location);
	Acceleration.Z *= 0.5;
	Destination = Location;
	Sleep(0.5);
	SetTimer(TimeBetweenAttacks, false);
	Goto('TacticalTick');
}


defaultproperties {
	AccelRate=600
	Aggressiveness=1
	AirSpeed=250
	AmbientSound=Sound'UnrealShare.Razorfish.ambfs'
	bCanStrafe=True
	bCanFly=True
	BiteDamage=15
	Buoyancy=60
	CarcassType=Class'UnrealShare.DevilfishCarcass'
	CollisionHeight=20
	CollisionRadius=35
	CombatStyle=1
	Die=Sound'UnrealShare.Razorfish.death1fs'
	DrawType=DT_Mesh
	GroundSpeed=250
	Health=70
	HitSound1=Sound'UnrealShare.Razorfish.chomp1fs'
	HitSound2=Sound'UnrealShare.Razorfish.miss1fs'
	Intelligence=BRAINS_NONE
	JumpZ=10
	Land=Sound'UnrealShare.Razorfish.flop1fs'
	MeleeRange=40
	MenuName="Flying Fish"
	Mesh=LodMesh'UnrealShare.fish'
	rip=Sound'UnrealShare.Razorfish.tear1fs'
	RipDamage=25
	RotationRate=(Pitch=8192,Roll=8192)
	SightRadius=1250
	TimeBetweenAttacks=0.5
	UnderWaterTime=-1
	Visibility=120
	WaterSpeed=250
	WalkingSpeed=250
}
